/*~!DO NOT EDIT!~
* This file was automatically generated by GSharpDSL.
* No changes will be saved on next compilation.
* @Zestas Orestis.
*/

using GraphLibrary;
using System;
using System.Collections.Generic;
using GraphLibrary.Algorithms;

namespace GSharpDSL {

    public class AlgOneQueryInfo : CGraphQueryInfo<NodePathInfo,String,Dictionary<CGraphNode,Dictionary<CGraphNode,Path>>> {    
        //CONSTRUCTOR    
        public AlgOneQueryInfo(CGraph graph, object key) : base(graph,key) { }    

        //NODE MEMBERS ACCESSORS        
        public Int32? MDistance(CGraphNode node) {        
            return Info(node).MDistance;        
        }        
        public CGraphNode MPredecessor(CGraphNode node) {        
            return Info(node).MPredecessor;        
        }        
        //NODE MEMBERS MODIFIERS        
        public void SetMDistance(CGraphNode node, Int32? MDistance) {        
            Info(node).MDistance = MDistance;        
        }        
        public void SetMPredecessor(CGraphNode node, CGraphNode MPredecessor) {        
            Info(node).MPredecessor = MPredecessor;        
        }        
        //NODE ACCESSOR        
        public NodePathInfo GetNodeInfo(CGraphNode node) {        
            return Info(node);        
        }        
        //NODE MODIFIER        
        public void SetNodeInfo(CGraphNode node, NodePathInfo info) {        
            CreateInfo(node, info);        
        }        
        //EDGE ACCESSOR        
        public String GetEdgeInfo(CGraphEdge edge) {        
            return Info(edge);        
        }        
        //EDGE MODIFIER        
        public void SetEdgeInfo(CGraphEdge edge, String info) {        
            CreateInfo(edge, info);        
        }        
        //GRAPH ACCESSOR        
        public Dictionary<CGraphNode,Dictionary<CGraphNode,Path>> GetGraphInfo() {        
            return Info();        
        }        
        //GRAPH MODIFIER        
        public void SetGraphInfo(Dictionary<CGraphNode,Dictionary<CGraphNode,Path>> info) {        
            CreateInfo(info);        
        }        

    }
    //CGraphAlgorithm    
    public partial class AlgOne : CGraphAlgorithm<int> {    
        private AlgOneQueryInfo m_outputAlgOneQueryInfo;    
        private string MYINT_KEY = "myintBank";        

        //CGraphAlgorithm CONSTRUCTOR        
        public AlgOne(CGraph graph, object graphKEY) {        
            m_outputAlgOneQueryInfo = new AlgOneQueryInfo(graph, graphKEY);        
        }        
        //CGraphAlgorithm NODE MEMBERS ACCESSORS        
        protected Int32? MDistance(CGraphNode node) {        
            return m_outputAlgOneQueryInfo.MDistance(node);        
        }        
        protected CGraphNode MPredecessor(CGraphNode node) {        
            return m_outputAlgOneQueryInfo.MPredecessor(node);        
        }        
        //CGraphAlgorithm NODE MEMBERS MODIFIERS        
        protected void SetMDistance(CGraphNode node, Int32? MDistance) {        
            m_outputAlgOneQueryInfo.SetMDistance(node, MDistance);        
        }        
        protected void SetMPredecessor(CGraphNode node, CGraphNode MPredecessor) {        
            m_outputAlgOneQueryInfo.SetMPredecessor(node, MPredecessor);        
        }        
        //CGraphAlgorithm NODE ACCESSOR        
        protected NodePathInfo GetNodeInfo(CGraphNode node) {        
            return m_outputAlgOneQueryInfo.GetNodeInfo(node);        
        }        
        //CGraphAlgorithm NODE MODIFIER        
        protected void SetNodeInfo(CGraphNode node, NodePathInfo info) {        
            m_outputAlgOneQueryInfo.SetNodeInfo(node, info);        
        }        
        //CGraphAlgorithm EDGE ACCESSOR        
        protected String GetEdgeInfo(CGraphEdge edge) {        
            return m_outputAlgOneQueryInfo.GetEdgeInfo(edge);        
        }        
        //CGraphAlgorithm EDGE MODIFIER        
        protected void SetEdgeInfo(CGraphEdge edge, String info) {        
            m_outputAlgOneQueryInfo.SetEdgeInfo(edge, info);        
        }        
        //CGraphAlgorithm GRAPH ACCESSOR        
        protected Dictionary<CGraphNode,Dictionary<CGraphNode,Path>> GetGraphInfo() {        
            return m_outputAlgOneQueryInfo.GetGraphInfo();        
        }        
        //CGraphAlgorithm GRAPH MODIFIER        
        protected void SetGraphInfo( Dictionary<CGraphNode,Dictionary<CGraphNode,Path>> info) {        
            m_outputAlgOneQueryInfo.SetGraphInfo(info);        
        }        
        
        private void StoreOutput(string key, object value) {        
            IOBank.SetValueForItemInBank(key,value);        
        }
    }

}
